;-------------------------------------------------
; fftshift
; Intro. IDL program. (2013): Chapt. 5.2   
; Author:  Tadashi Ito     
;-------------------------------------------------
function fftshift, indata
insize=SIZE(indata)
xdsize=insize[1]
ydsize=insize[2]
shiftsizeX=FIX(xdsize/2)
shiftsizeY=FIX(ydsize/2)
outdata=indata
quad=indata[0:shiftsizeX-1,0:shiftsizeY-1]
outdata[shiftsizeX,shiftsizeY]=quad
quad=indata[shiftsizeX:xdsize-1,shiftsizeY:ydsize-1]
outdata[0,0]=quad
quad=indata[0:shiftsizeX-1,shiftsizeY:ydsize-1]
outdata[shiftsizeX,0]=quad
quad=indata[shiftsizeX:xdsize-1,0:shiftsizeY-1]
outdata[0,shiftsizeY]=quad
return, outdata
end