;-------------------------------------------------
; fopt_2;  Fourier Optics_2
; Intro. IDL program. (2013): Chapt. 5.3.4   
; Author:  Tadashi Ito     
;-------------------------------------------------
;--- quadratic phase factor
function qfac,lamda,z,d,n
im=dcomplex(0.,1.)
fac0=im*!PI/lamda/Z
x=(findgen(n)-n/2)*d
x2=x^2
y2=x2
qf=dcomplexarr(n,n)
for i=0,n-1 do qf[i,*]=exp(fac0*(x2[i]+y2[*]))
return, qf
end
;--- main routine
pro fopt_2
n=1024
lamda=0.002
Z=500000.
d=0.04
d=0.18
qf = qfac(lamda,Z,d,n)
device,decomposed=0
loadct,0
window,0
shade_surf,real_part(qf),ax=75,az=0,xstyle=4,ystyle=4,zstyle=4
window,1
shade_surf,imaginary(qf),ax=75,az=0,xstyle=4,ystyle=4,zstyle=4
end