;-------------------------------------------------
; GUI_5_1
; Intro. IDL program. (2013): Chapt. 6.5  
; Author:  Tadashi Ito     
;-------------------------------------------------
pro b1_ev,ev
widget_control, ev.top, get_uvalue=uv0
path=expand_path('<idl_dir>')+path_sep()+'examples\data'
fname = dialog_pickfile(path=path,filter=['*.jpg','*.tif'])
img1=read_image(fname)
help,img1
sz=size(img1)
ptr_free,uv0.p1
uv0.p1=ptr_new(img1,/no_copy)
wset, uv0.w1_id
erase
if sz[0] eq 3 then begin
    device,decomposed=1
    tv,*uv0.p1, true=1        
    endif else begin
        device,decomposed=0
        tv,*uv0.p1  
        endelse
widget_control, ev.top, set_uvalue=uv0, /no_copy
end
;-------------------------------------
pro b2_ev,ev
widget_control,/destroy,ev.top
end
;-------------------------------------
pro gui_5_1_event,ev
end
;------------------------------------
pro gui_5_1
g0_id=widget_base(title='gui_5_1',/row)
g1_id=widget_base(g0_id, /frame, /column)
g2_id=widget_base(g0_id, /frame, /column,space=20)
wsiz=400
d1_id=widget_draw(g1_id,uname='d1',xsize=wsiz,ysize=wsiz)
b1_id=widget_button(g2_id,value='Load_data',uname='b1',event_pro='b1_ev')
b2_id=widget_button(g2_id,value='end',uname='b2',event_pro='b2_ev')
;----realize widget
widget_control, g0_id, /realize
;--- get window_id
widget_control,d1_id,get_value=w1_id
;---  set info structure in uvalue
uv0={w1_id:w1_id,p1:ptr_new()}
widget_control, g0_id, set_uvalue=uv0,/no_copy
;----start event loop
xmanager,'gui_5_1',g0_id,cleanup='myclean',/no_block
end
