;-------------------------------------------------
; my_wig_win ;  Widget window
; Intro. IDL program. (2013): Chapt. 8.2  
; Author:  Tadashi Ito     
;-------------------------------------------------
pro my_wig_win_event, ev
widget_control, ev.top, get_uvalue=uv0,/no_copy
uname = widget_info(ev.id, /uname)
case uname of
 'lst1': begin
         ctno = ev.index
         uv0.oimg.rgb_table=ctno
         end
 'ww1': if ev.type eq 2 then begin
        txt=string(ev.x, ev.y,(*uv0.pdat)[ev.x,ev.y],format='(%"x %d  y %d  z %d")')
        widget_control, uv0.t1_id, set_value=txt        
        endif   
  else:    
  endcase
widget_control, ev.top, set_uvalue=uv0,/no_copy  
end
;---------------- cleanup routine
pro my_wig_win_cleanup, base
widget_control, base, get_uvalue=uv0,/no_copy
ptr_free,uv0.pdat
end
;---------------- main routine
pro my_wig_win
;---restore 'elev' data
restore,filename=file_which('marbells.dat')
g0_id = widget_base(/row, title='my_widget_window')                                      
;--- widget window  
ww1_id = widget_window(g0_id,xsize=350,ysize=450,uname='ww1',/motion_events) 
;--- list
loadct,get_names=ctnames
g1_id = widget_base(g0_id, /column)
l1_id=widget_label(g1_id,value='Color Table',/align_left)
lst1_id=widget_list(g1_id,value=ctnames,uname='lst1',ysize=30)
;--- text 
l2_id=widget_label(g1_id,value='Position and elevation',/align_left)                                                
t1_id = widget_text(g1_id,uname='t1')
widget_control, g0_id, /realize
;--- create plot-object on current window
oimg=image(elev,rgb_table=17,margin=0,/current)
;--- state structure
pdat = ptr_new(elev, /no_copy)
uv0 = { g0_id:g0_id, t1_id:t1_id, oimg:oimg, pdat:pdat }
widget_control, g0_id, set_uvalue=uv0 ,/no_copy
xmanager, 'my_wig_win', g0_id, /no_block, $
cleanup='my_wig_win_cleanup',event_handler='my_wig_win_event'         
end
