;-------------------------------------------------
; mysinc2d 
; 2-dimensional sinc distribution
; Intro. IDL program. (2013): Chapt. 4.2.1   
; Author:  Tadashi Ito     
;-------------------------------------------------
function mysinc2d,n,step=step,int=int,x=x,y=y
if n_params() ne 1 then n=50
if ~keyword_set(step) then step=1.
if ~keyword_set(int) then int=1. 
x=(findgen(n)-n*0.5)*step
y=x
x2=x^2
y2=x2
r=fltarr(n,n)    
for i=0,n-1 do r[i,*]=sqrt((x2[i]+y2[*]))
return, int*sin(r>1.e-6)/(r>1.e-6)
end