;-------------------------------------------------
; GUI_4_1
; Intro. IDL program. (2013): Chapt. 6.4 
; Author:  Tadashi Ito     
;-------------------------------------------------
pro b1_ev,ev
widget_control, ev.top, get_uvalue=uv0, /no_copy
widget_control, uv0.t1_id, get_value=cax1 
widget_control, uv0.t2_id, get_value=caz1 
widget_control, uv0.t3_id, get_value=cctb
ax1=c_to_i(cax1) & uv0.ax=ax1
az1=c_to_i(caz1) & uv0.az=az1
ctb1=c_to_i(cctb)
if ctb1 le 40 then begin
  if ctb1 ne uv0.ctb then loadct,ctb1
uv0.ctb=ctb1
endif
shade_surf,uv0.zd,uv0.xd,uv0.yd,ax=uv0.ax,az=uv0.az
widget_control, ev.top, set_uvalue=uv0, /no_copy
end
;---------------------------------------
pro b2_ev,ev
widget_control, ev.top, get_uvalue=uv0, /no_copy
widget_control, uv0.t3_id, get_value=cctb
ctb1=c_to_i(cctb)
if ctb1 le 40 then begin
  if ctb1 ne uv0.ctb then loadct,ctb1
uv0.ctb=ctb1
endif
wset,uv0.w1_id
erase
tvscl,congrid(uv0.zd,!d.x_size,!d.y_size,/interp)
widget_control, ev.top, set_uvalue=uv0, /no_copy
end
;----------------------------------------
pro b3_ev,ev
widget_control,/destroy,ev.top
end
;----------------------------------------
pro gui_4_1_event,ev
end
;----------------------------------------
pro gui_4_1
g0_id=widget_base(title='GUI_4_1',/row)
g1_id=widget_base(g0_id, /frame, /column)
g2_id=widget_base(g0_id, /frame, /column)
g3_id=widget_base(g0_id, /frame, /column, space=10)
wsiz=400
d1_id=widget_draw(g1_id,uname='d1',xsize=wsiz,ysize=wsiz)
L1_id=widget_label(g2_id,value='angl_x',uname='L1')
t1_id=widget_text(g2_id, uname='t1', /editable, xsize=10, ysize=1)
L2_id=widget_label(g2_id,value='angl_z',uname='L2')
t2_id=widget_text(g2_id, uname = 't2', /editable, xsize=10, ysize=1)
L3_id=widget_label(g2_id,value='color',uname='L3')
t3_id=widget_text(g2_id, uname='t3', /editable, xsize=10, ysize=1)
b1_id=widget_button(g3_id,value='surf_plot',uname='b1',event_pro='b1_ev')
b2_id=widget_button(g3_id,value='tv_plot',uname='b2',event_pro='b2_ev')
b3_id=widget_button(g3_id,value='end',uname='b3',event_pro='b3_ev')
;--- set rotation angle and color table
ax=30 & az=30 & ctb=0
widget_control,t1_id,set_value=string(ax)
widget_control,t2_id,set_value=string(az)
widget_control,t3_id,set_value=string(ctb)
;----realize widgets
widget_control, g0_id, /realize
;--- display image
widget_control,d1_id,get_value=w1_id
wset,w1_id
device,decomposed=0
zd=mysinc2d(100,step=0.5,x=xd,y=yd)
loadct,ctb
shade_surf,zd,xd,yd,ax=ax,az=az
;--- store state structure uv0 in uvalue
uv0={w1_id:w1_id,t1_id:t1_id,t2_id:t2_id,t3_id:t3_id, $
zd:zd,xd:xd,yd:yd, ax:ax, az:az, ctb:ctb}
widget_control, g0_id, set_uvalue=uv0, /no_copy
;----start event loop
xmanager,'gui_4_1',g0_id,/no_block
end
