;-------------------------------------------------
; mkoearth_p ; creates the earth object by polygon
; Intro. IDL program. (2013): Chapt. 7.2.4   
; Author:  Tadashi Ito     
;-------------------------------------------------
function mkoearth_p,div=div,oetx=oetx,scale=scale
;---make the earth using polygon and texture
dv=360
r=0.5
if keyword_set(div) then dv=div
if keyword_set(scale) then r=r*scale
mesh_obj,4,vtx,pgn,fltarr(dv,dv) + r
;---create the earth.
opoly=obj_new('IDLgrPolygon',vtx,polygons=pgn, $
         color=[255,255,255], style=2, shading=1)
;---jpeg texture file
read_jpeg,filepath('day.jpg',subdirectory=['examples','data']),img
img=congrid(img,3,dv,dv)
oetx=obj_new('IDLgrImage',img)
;---texture coord
txc = fltarr(2,dv,dv)
for i=0, dv-1 do txc[0,*,i]=findgen(dv)/dv
for i=0, dv-1 do txc[1,i,*]=findgen(dv)/dv
opoly->setproperty,texture_map=oetx,texture_coord=txc    
return, opoly        
end