;-------------------------------------------------
; mkoview ; creates view object
; Intro. IDL program. (2013): Chapt. 7.2.7   
; Author:  Tadashi Ito     
;-------------------------------------------------
function mkoview,viewplane_rect=rect,zclip=zc,eye=eye,projection=proj,color=color
;---make my view
rect =  (keyword_set(rect))? rect : [-1.,-1.,2.,2.]
zc =    (keyword_set(zc))? zc : [10,-20]
eye =   (keyword_set(eye))? eye : 11
proj =   (keyword_set(eye))? proj : 1
color = (keyword_set(color))? color : [0,0,0]
return, obj_new('IDLgrView',viewplane_rect=rect, $
         color=color, zclip=zc, projection=proj, eye=eye)
end