;-------------------------------------------------
; my_fft 
; Intro. IDL program. (2013): Chapt. 5.2   
; Author:  Tadashi Ito     
;-------------------------------------------------
pro my_fft
im=dcomplex(0.,1.)
rev=im*2.*!PI
N=8
k=indgen(N)
j1=2
a1=0.7
j2=6
a2=-0.5
gj=a1*exp(rev*j1*k/N)+a2*exp(rev*j2*k/N)
fg=fft(gj)
for i=0,N-1 do print,k[i],float(fg[i]),imaginary(fg[i]), $
    format='(2Hk=,i3,2x,2HRe,f10.4,2x,2HIm,f10.4)'
gj2=fft(fg,/inverse)
for i=0,N-1 do print,k[i],float(gj[i]),float(gj2[i]), $
    imaginary(gj[i]),imaginary(gj2[i]),format='(2Hk=,i3,4(2x,f10.4))'
end
