;-------------------------------------------------
; netCDF_write 
; Intro. IDL program. (2013): Chapt. 3.9.7   
; Author:  Tadashi Ito     
;-------------------------------------------------
pro netCDF_write
fname='d:\netCDF.nc'
nx=5
ny=3
vals=dindgen(nx,ny)+1.
cdfid = ncdf_create(fname, /clobber)
xdimid = ncdf_dimdef(cdfid,'xdim',nx)
ydimid = ncdf_dimdef(cdfid,'ydim',ny)
varid = ncdf_vardef(cdfid,'data', [xdimid,ydimid], /double)
ncdf_attput, cdfid, varid, 'long_name', $
'test to create nCDF file'
ncdf_attput, cdfid, 'creation_date', systime(), /global
ncdf_control, cdfid, /endef
ncdf_varput, cdfid, varid, vals
ncdf_close, cdfid
end
